//
// Copyright (C) 1999-2002 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#ifndef WSDBTRONSOCKET_H
#define WSDBTRONSOCKET_H

#include <WScom.h>
#include <WSDsocket.h>

class WSDbtronSocket  :public WSDsocket{
 protected:
  int _socket;
  WSCbool _listened;
  void*   _sem;
  WSCstring _error_str;
  WSCbool _no_delay;

  virtual long initialize();
  virtual long destroy();

  static void _accept_thread_(W);
  static void _udp_read_thread_(W);
  void seterr(int val = -1);
 public:
  WSDbtronSocket();
  virtual ~WSDbtronSocket();
  virtual long connect();
  virtual long listen();
  virtual void* accept();
  virtual long acceptEx(void(*)(WSDsocket*,void*,WSCulong));
  virtual long _continue_udp_read_accept();

  virtual long read(void* handle,WSCuchar* buf,long size);
  virtual long write(void* handle,WSCuchar* buf,long size);
  virtual long read(WSCuchar* buf,long);
  virtual long write(WSCuchar* buf,long);

  virtual long close(void* sock = NULL);

  virtual WSCstring getLastError();  

  WSMFclassDef(WSDbtronSocket,WSDsocket);
};
struct _accept_send_type{
  WSDbtronSocket* sock;
  int         socket;
  WSCulong    addr;
  void(*hd)(WSDsocket*,void*,WSCulong);
};

#endif //WSDBTRONSOCKET_H
